	TITLE ALGB External Declarations
*******************************************************************
*   ALGB Library external declarations file.  This file should    *
*   be included in all source modules.                            *
*******************************************************************
********************
*   Noms visbles   *
********************
* page 1
EXTERNAL xXY
EXTERNAL xMMULT
EXTERNAL xTRAN
EXTERNAL xTR
EXTERNAL xMADJ
EXTERNAL xCROSS
* page 2
EXTERNAL xGCD
EXTERNAL xLCM
EXTERNAL xSIMPF
EXTERNAL xDIVIS
EXTERNAL xLGCD
EXTERNAL xRAC
* page 3
EXTERNAL xPOLY
EXTERNAL xSOLV
EXTERNAL xEVIDENT
EXTERNAL xDEG2
EXTERNAL xRACMUL
EXTERNAL xFACTR
* page 4
EXTERNAL xAL
EXTERNAL xXFL
EXTERNAL xAP
EXTERNAL xNUM
EXTERNAL xQ
EXTERNAL xtEVAL
* page 5
EXTERNAL xLVAR
EXTERNAL xGETEV
EXTERNAL xTOSET
EXTERNAL xNEXTP
EXTERNAL xREVLIST
EXTERNAL xDOALL
* page 6
EXTERNAL xFXND
EXTERNAL xNDXF
EXTERNAL xCALC
EXTERNAL xORND
EXTERNAL xi
EXTERNAL xDEGRE
* page 7
EXTERNAL xPTAYL
EXTERNAL xVAL
EXTERNAL xMEVAL
EXTERNAL xTRIM
EXTERNAL xDER
EXTERNAL xPINTG
* page 8
EXTERNAL xADD
EXTERNAL xSUBT
EXTERNAL xMULT
EXTERNAL xDIV
EXTERNAL xP^N
EXTERNAL xCHS
* page 9
EXTERNAL xVER

* 49 XLIB nomms = #31    *

***************************
*      Nullnamed XLIB     *
***************************

* 0 (ROMPTR 314 36)

EXTERNAL LXAext  ( liste -> array )
* Transforme 1 liste (niveau 1) en tableau (si possible)
EXTERNAL AXLext  ( array -> liste )
* Transforme un tableau en liste
EXTERNAL LXFext  ( num, deno -> num/deno )
* transforme une fraction du format numrateur, dnominateur
* polynmes-listes ou entiers au format algbrique
EXTERNAL FXLext  ( fraction -> poly2, poly1 ou real2, real1 )
* inverse de LXFext
EXTERNAL LXXext  ( polynme-liste -> polynme algbrique )
* par exemple { 2 1 -1 } -> -1+X+2*X^2

EXTERNAL XXLext  ( polynme algbrique -> polynme liste )
* inverse de LXXext
EXTERNAL CALCext ( algbrique -> fraction algbrique )
* rduit au mme dnominateur des fractions
EXTERNAL ELMGext ( algbrique polynmial -> polynme dvelopp )
* Dveloppe par rapport  toutes les variables rencontres
* Remplace par 0 les rels infrieurs  epsilon
EXTERNAL ELMG3ext ( algbrique, entier -> algbrique )
* Arrondit les scalaires de l'algbrique s'il sont proches
* d'un rationnel de dnominateur l'entier au niveau 1
EXTERNAL FACT1ext ( polynme -> poly-liste, {liste des racines} )
* Factorise un polynme, renvoie le coefficient dominant
* et la liste des racines.

*10

EXTERNAL FACTOext  ( polynme ou entier -> liste des facteurs ou racines )
* pour un polynme, appelle FACT1ext puis "drop" le niveau 2
EXTERNAL SOLVext   ( polynme-liste -> liste des racines )
( ou polynme-liste, epsilon, nombre d'itrations -> liste des racines )
* Factorise un polynme-liste  coeffcients rels ou complexes
* par la mthode de Laguerre ou de Bairstow.
EXTERNAL EVIDENText  ( polynme-liste -> liste de racines )
* Recherche les racines rationnelles d'un polynme (permet aussi de
* factoriser certains polynmes  coefficients formels)
EXTERNAL DEG2ext     ( polynme-liste de degr < 3 -> liste des racines )
* Factorisation d'un polynme de degr 2 (ventuellement formel)
EXTERNAL RACMULext   ( polynme-liste P -> P, PGCD{P,P'} )
* Calcule le PGCD des polynmes P et P' pour dterminer
* ses racines multiples (si le User Flag 2 est arm)

EXTERNAL ADDext      ( { poly2 } { poly1 } --> { poly2 + poly1 } )
* Additionne deux polynmes listes
EXTERNAL SOUSext     ( { poly2 }, { poly1 } --> { poly2 - poly1 } )
* Soustrait deux polynmes listes
EXTERNAL MULText     ( { poly2 }, { poly1 } --> { poly2 * poly1 } )
* Multiplie deux polynmes listes
EXTERNAL ASOPext  ( { poly2 } { poly1 } oprateur binaire --> { poly3 } )
* Effectue l'addition ou la soustraction de deux polynmes selon l'oprateur
* plac au niveau 1 de la pile
EXTERNAL DIVext      ( obj2, obj1 -> obj2 DIV obj1 , obj2 MOD obj1 )
* Division euclidienne de 2 polynmes-listes ou de 2 rels
* calcule le quotient et le reste

*20

EXTERNAL DERext     ( polynme-liste -> drive )
EXTERNAL INTEGRext  ( polynme-liste -> primitive )
* calcule la primitive s'annulant en 0
EXTERNAL LOPAext    ( liste, objet, oprateur binaire -> liste )
* List Operation All
EXTERNAL LOPMext    ( objet, liste -> { objet * elements de liste } )
* List Operation Multiplication
EXTERNAL LRDMext    ( liste entier -> liste )
* Rajoute des 0  gauche pour obtenir un polynme "de degr" gal 
* l'entier spcifi (entier est un rel ou un binaire)

EXTERNAL RRDMext    ( liste entier -> liste )
* Comme LRDM mais cre des zeros  droite
EXTERNAL TRIMext    ( liste -> liste )
* Enlve les zros en tte de liste
EXTERNAL DIVEext    ( poly-liste, poly-liste -> P1 DIV P2, P1 MOD P2 )
* division euclidienne,  un polynme inversible prs.
EXTERNAL DEGREext   ( objet -> degre )
* renvoie le degr d'un polynme-liste
EXTERNAL RACPOLext  ( liste de racines ou de facteurs -> polynme ou entier )
* Inverse de FACTO. Si le UserFlag 10 est arm, il s'agit de facteurs
* entiers, sinon de racines.

*30

EXTERNAL FXNDext    ( objet -> numrateur, dnominateur )
* Dcompose une fraction
EXTERNAL NDXFext    ( numrateur, dnominateur -> algbrique )
* inverse de FXND
EXTERNAL VXXLext    ( algbrique ID -> polynme-liste )
EXTERNAL LVARext    ( objet -> liste des identificateurs globaux )
EXTERNAL VALext     ( P, x -> P[x] ou P, { x1,..., xn } -> P[x1,...,xn] )

EXTERNAL NULext     ( -> element neutre )
* Renvoie l'lment neutre courant (selon le UserFlag 10: 0 pour les entiers
* ou { 0 } pour les polynmes.
EXTERNAL GETEVext   ( liste d'actions liste objet -> )
* si objet est dans la liste  la position n, excute l'action n
* sinon excute la dernire action de la liste, l'objet est dans ce cas
* conserv sur la pile sinon il est dtruit
EXTERNAL Xiext    ( objet -> objet )
* Ecrit les complexes sous forme formelle (a,b) -> a+i*b
EXTERNAL PGCDext    ( o2 o1 -> PGCD[o2,o1] )
* Plus grand diviseur commun (entier, polynme listes ou algbriques)
* xNAME xPPMC    ( P1, P2 -> PPMC[P1,P2] )
* PPMC*PGCD=P1*P2

*40

EXTERNAL SIMPext    ( o1, o2 -> o1' o2' )
* Simplifie o1/o2 en o1'/o2' par division par le PGCD de o1 et o2
EXTERNAL CSQRext    ( algbrique -> algbrique simplifi false ou true )
* Recherche une racine carre dans l'algbrique, renvoie false s'il
* n'en trouve pas et true s'il en trouve (simplifie alors l'expression)
EXTERNAL MPext ( objet, #entier, prg de multiplication -> objet^#entier )
EXTERNAL LSQRext    ( \sqrt{a}, a, P[a,\sqrt{a}] -> \sqrt{a}, P-liste )
EXTERNAL MEVALext   ( objet, 'o1=o2' -> remplace o1 par o2 dans objet )

EXTERNAL FSQRext    ( algbrique -> false ou \sqrt{a}, a, true )
* Find SQuare Root
EXTERNAL RACext     ( entier ou polynme algbrique -> racine carre )
EXTERNAL XSQRext    ( objet, entier -> racine nime de l'objet )
* Sert essentiellement  prendre la racine carre d'un objet
* avec comme entier %2
* EXTERNAL TABSext    ( objet -> valeur absolue ou 1 )
* Renvoie la valeur absolue pour un rel ou un complexe, sinon renvoie 1
EXTERNAL COMPRIMext ( liste -> liste comprime au sens ensembliste )

*50


EXTERNAL NEXTPext   ( liste -> liste1 liste2 )
* liste=liste1+liste2, liste2 est forme d'lments identiques
( { o1 o2 ... } -> { liste1 } { o1 ... o1 } )
( si Flag3 Set liste1=liste-{o1 ... o1 } )
( si Flag3 Clear liste1=liste-{o1 ... o1}-{conj[o1]...conj[o1]} )
EXTERNAL DIVISext   ( objet -> liste des diviseurs )
* objet peut tre algbrique ou entier
* dans le premier cas, DIVISext renvoie la liste des facteurs premiers
* dans le second cas, la liste des diviseurs si l'entier est <  #FFFFFh
EXTERNAL LPGCDext   ( liste -> PGCD de la liste )
EXTERNAL QOBJext    ( objet [runstream: programme] -> objet )
* Exxute programme par 'REVAL sur les lments de objet (pour des objets
* de type liste, algbrique ou array en les dcomposant)
EXTERNAL VERext     ( affichage de la version )
EXTERNAL XYext      ( vecteur x et y -> x.y produit scalaire )
EXTERNAL MMULText   ( matrice 1, matrice 2 -> produit des 2 matrices )
EXTERNAL TRANext    ( matrice -> matrice transpose )
EXTERNAL TRext      ( matrice -> trace )
EXTERNAL HORNext    ( polynome-liste P, r -> P[X] div [X-r], r, P[r] )
EXTERNAL BAIRSText  ( polynome-liste P, s ,p -> P[X] div [X*X-sX+p], s, p, R[X-s] )
* Division euclidienne par un polynome quadratique

*60


EXTERNAL PTAYLext   ( polynme-liste P, r -> dvpt Taylor de P en r )
EXTERNAL DTYPFMAT?  ( objet -> objet TRUE ou -> objet FALSE )
* Teste si on a affaire  une matrice formelle
EXTERNAL DTYPENDO? ( objet -> objet TRUE ou FALSE )
* Teste si objet est la matrice d'un endomorphisme (matrice carre)
* Convertit ventuellement une matrice numrique en matrice formelle
EXTERNAL CK2FPOLY ( -> )
* teste les niveaux 1 et 2 de la pile, si une liste vide est rencontre
* provoque une erreur
EXTERNAL LISTSECOext ( list, seco ou symb -> list, seco ou symb )
* Excute de manire non rcursive 1GETLAM sur les composants
* de list ou de seco
EXTERNAL RADDext  ( o1, o2 -> o1+o2 )
EXTERNAL RSUBext ( o1, o2 -> o1-o2 )
EXTERNAL RMULText ( o1, o2 -> o1*o2 )
EXTERNAL RDIVext ( o1, o2 -> o1/o2 )
EXTERNAL TOLISText ( algbrique -> variables, liste, TRUE ou
                   (               algbrique, FALSE )
* Si l'algbrique contient des variables globales, transforme en
* polynme-liste (ventuellement  plusieurs variables)

*70

EXTERNAL RMSYMext ( objet -> symbolique )
* Elimine les symboles imbriqus
EXTERNAL MADJext ( matrice M -> M^-1, P[M], P[lambda] )
* Calcule le polynme caractristique et le polynme matrice adjoint
* d'une matrice donne.
EXTERNAL MPMULText ( matrice M, polynme P-> M * P )
EXTERNAL DEPTHext ( objet -> # )
* Renvoie la profondeur de l'objet (en terme de listes)
EXTERNAL User1IT
* Execute l'objet au niveau 1  la manire de ERR$EVALext si UF1 est arm.

*75
EXTERNAL MENUext ( $6 $5 $4 $3 $2 $1 -> affichage du menu )
* Affiche les 6 chanes dans les 6 cases du menu
EXTERNAL BINDext ( # [ runstream # objets ] -> )
* Cre # variables locales contenant les # objets suivants du runstream
EXTERNAL ERR$EVALext ( seco ou numero d'erreur -> action )
* Pour un # effectue :: SWAP NOTcase :: # 31400 #+ DO#EXIT ; DROP ;
* Donc on peut faire un test puis # ERR$EVALext, ou # dsigne
* le numro d'erreur a executer si le test est false,
* Pour un % effectue teste le flag utilisateur %, si le test
* est ngatif, depile l'objet situ au niveau 2, sinon revient
*  l'excution normale, ceci permet un programme du type
* { ONE TWO &$ DISPROW1 } %1 ERR$EVALext qui affiche la concatnation
* des messages 1 et 2 lorsque le flag 1 est arm.
* Sinon excute le programme, la liste ou le symbolique
* (EVAL de chaque objet) mais pour les entiers
* systmes non taggus, remplace ces entiers par #31400+# et
* excute JstGETTHEMESG (rappelle le message d'erreur # de ALGB)
* Exemple :: ONE TWO &$ DISPROW1 ; ERR$EVALext
* rappelle les messages 1,2 les concatne et affiche le rsultat
* en ligne 1.
* Attention, les NULLLAM sont dcals de 2 et les compteurs de
* boucles de 1
